package pl.asie.foamfix.common;

import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityHopper;

public class TileEntityFasterHopper extends TileEntityHopper {
    private boolean empty, full;
    private boolean dirtyEmpty, dirtyFull;

    @Override
    public void func_145829_t() {
        super.func_145829_t();
        dirtyEmpty = true;
        dirtyFull = true;
    }

    public void updateFlagEmpty() {
        empty = true;

        for (ItemStack stack : func_190576_q()) {
            if (!stack.func_190926_b()) {
                empty = false;
                return;
            }
        }
    }

    public void updateFlagFull() {
        full = true;

        for (ItemStack stack : func_190576_q()) {
            if (stack.func_190926_b() || stack.func_190916_E() < stack.func_77976_d()) {
                full = false;
                return;
            }
        }
    }

    @Override
    public ItemStack func_70304_b(int index) {
        ItemStack stack = super.func_70304_b(index);
        if (!stack.func_190926_b()) {
            dirtyEmpty = true;
            full = false; // Something was taken out, so it won't be full anymore
        }
        return stack;
    }

    @Override
    public ItemStack func_70298_a(int index, int count) {
        ItemStack stack = super.func_70298_a(index, count);
        if (!stack.func_190926_b()) {
            dirtyEmpty = true;
            full = false; // Something was taken out, so it won't be full anymore
        }
        return stack;
    }

    @Override
    public void func_70299_a(int index, ItemStack stack) {
        super.func_70299_a(index, stack);
        dirtyEmpty = true;
        dirtyFull = true;
    }

    @Override
    protected boolean func_152104_k() {
        if (dirtyEmpty) {
            updateFlagEmpty();
            dirtyEmpty = false;
        }
        return empty;
    }

    @Override
    protected boolean func_152105_l() {
        if (dirtyFull) {
            updateFlagFull();
            dirtyFull = false;
        }
        return full;
    }
}
